<html>
<body>
<!-- #include file=ExcelADO.asp -->
<%
'Important include file above. you can insert the class code directly into the page, but for plug and play easy, leave it in an include file.
'See ExcelADO.htm for full instructions

' ExcelADO Demo
' Excel File access via ADO
' Written by Hunter Beanland
' http://www.geocities.com/hbeanland/
' hbeanland@yahoo.com.au

	Dim ArrayIndex
	'Create an instance of the ExcelADO class
	Dim MyExcelFile
	Set MyExcelFile = New ExcelADO
	
	'If you wish to use the Excel driver or Text Driver, set it before opening the spreadsheet
	'MyExcelFile.Driver = MyExcelFile.DriverExcel

	'Open the Demo spreadsheet was error checking
	Response.Write("<font face='arial'><b>Opening Demo Spreadsheet:</b><br>")
	if not MyExcelFile.OpenSpreadsheet("ExcelDemo.xls") then
		'The filenames are stored here during the open process
		Response.Write(MyExcelFile.AbsoluteFileName & " (" & MyExcelFile.VirtualFileName & ")<br>")
		Response.Write(MyExcelFile.ErrorText & "<br>")
	else
		'The filenames are stored here during the open process
		Response.Write(MyExcelFile.AbsoluteFileName & " (" & MyExcelFile.VirtualFileName & ")<br>")
		Response.Write("Open<br>")
	end if
	'Flush now so we can see what's going on
	Response.Flush

	'Display the Tables found when we opened the spreadsheet
	Response.Write("<p><b>Worksheets & Named Areas Found:</b> (worksheets have a $ after them)<br>")
	For ArrayIndex = 0 to MyExcelFile.NumTables - 1  'Tables are referenced from 0 not 1
		Response.Write(MyExcelFile.Tables(ArrayIndex) & "<br>")
	Next
	
	'Add additional SQL criteria. If omitted, then all records are returned in default order etc
	'MyExcelFile.SQLStatement = "where KeyCode <> 'test' order by SALUTATION"

	'Open a worksheet for reading (faster then write mode) via it's name (and a $ after as it is a worksheet) - with error checking
	Response.Write("<p><b>Opening worksheet:</b> 'Demo' (or Demo$ as the ODBC driver sees it)<br>")
	if not MyExcelFile.OpenWorksheet("Demo$", MyExcelFile.forReading) then
		Response.Write(MyExcelFile.ErrorText & "<br>")
	else
		Response.Write("Open<br>")

		'Display the Columns found when we opened the worksheet
		Response.Write("<p><b>Columns Names and Data Found:</b><br>")
		Response.Write("<table cellpadding='1' cellspacing='1' border='1' style='border-collapse: collapse; font-family: Arial; font-size: 10pt;' bordercolor='#111111'><tr bgcolor='#ccffcc'>")
		For ArrayIndex = 0 to MyExcelFile.NumColumns -1  'Columns are referenced from 0 not 1
			Response.Write("<td>" & MyExcelFile.Columns(ArrayIndex) & "</td>")
		Next
		
		'Display each data row via the ReadRow method
		While MyExcelFile.ReadRow
			Response.Write("</tr><tr>")
			For ArrayIndex = 0 to MyExcelFile.NumColumns -1
				Response.Write("<td>" & MyExcelFile.ColumnData(ArrayIndex) & "</td>")
			Next
		wend	
		Response.Write("</tr></table>")
		
		'Close that worksheet (Opening another worksheet automatically closes the previous sheet)
		MyExcelFile.CloseWorksheet
	end if
	
	'Open a named space for writing via it's table index (TestName) - with error checking
	Response.Write("<p><b>Opening Named Space:</b><br>")
	if not MyExcelFile.OpenWorksheet(MyExcelFile.Tables(3), MyExcelFile.forWriting) then
		Response.Write(MyExcelFile.ErrorText & "<br>")
	else
		Response.Write("Open<br>")
		
		'Display the Columns found when we opened the named space - note blank or unnamed columns are given a name starting from F1 (column A)
		Response.Write("<p><b>Columns Names and Data Found:</b><br>")
		Response.Write("<table cellpadding='1' cellspacing='1' border='1' style='border-collapse: collapse; font-family: Arial; font-size: 10pt;' bordercolor='#111111'><tr bgcolor='#ccffcc'>")
		For ArrayIndex = 0 to MyExcelFile.NumColumns -1
			Response.Write("<td>" & MyExcelFile.Columns(ArrayIndex) & "</td>")
		Next
		
		'Display each data row via the recordset method
		While not MyExcelFile.objRSXL.EOF
			Response.Write("</tr><tr>")
			For ArrayIndex = 0 to MyExcelFile.NumColumns -1
				Response.Write("<td>" & MyExcelFile.objRSXL(ArrayIndex) & "</td>")
				'These are alternate ways of doing it:
				'Response.Write("<td>" & MyExcelFile.objRSXL(MyExcelFile.Columns(ArrayIndex)) & "</td>") ' - use the column names instead of index #. No benefit to this
				'Response.Write("<td>" & MyExcelFile.objRSXL("KeyCode") & "</td>") ' - name each column explicitly
			Next
			MyExcelFile.objRSXL.MoveNext ' if forReading then only MoveNext is supported. forWriting supports dynamic cursors.
		wend	
		Response.Write("</tr></table>")
		
		'Close that worksheet (Opening another worksheet automatically closes the previous sheet)
		MyExcelFile.CloseWorksheet
	end if

	'Open a named space for writing via it's table index (TestName) - with error checking. Directory must be writable by IIS
	Response.Write("<p><b>Opening Sheet2:</b><br>")
	if not MyExcelFile.OpenWorksheet("Demo$", MyExcelFile.forWriting) then
		Response.Write(MyExcelFile.ErrorText & "<br>")
	else
		Response.Write("Open<br>")

		MyExcelFile.objRSXL.AddNew
		MyExcelFile.objRSXL(0) = "Newly"
		MyExcelFile.objRSXL(1) = "inserted"
		MyExcelFile.objRSXL(2) = "row"
		MyExcelFile.objRSXL.Update
		
		'Close the worksheet (Closing the spreadsheet will do this anyway)
		MyExcelFile.CloseWorksheet
	end if

	'Close the Spreadsheet (destroying the object - setting it to nothing - will do this anyway)
	MyExcelFile.CloseSpreadsheet
	Response.Write("<p><b>Spreadsheet Closed</b><br>")
	
	'Destroy the object, releasing memory and closing resources if open
	Set MyExcelFile = nothing

%>
</body>
</html>